﻿<?php
/*
 * 元宝支付 https://www.18pay.net
 * Date: 2020/12/10
 * Time: 15:38
 * 说明：
 * 以下代码只是为了方便商户测试而提供的样例代码，商户可以根据自己网站的需要，按照技术文档编写,并非一定要使用该代码。
 * 该代码仅供学习和研究接口使用，只是提供一个参考，最终解释权归美奇软件开发工作室所有。
 * 严禁一切钓鱼、色情、赌博、私彩及违反国家法律法规等使用。
 * 注意：
 * UTF-8编码不要在记事本下编辑，否则会出现一些奇葩的问题，正确方法应在开发工具里打开编辑
 */
ini_set("error_reporting","E_ALL & ~E_NOTICE");
header('Content-Type:application/json; charset=utf-8');
require "Des.php";
/////////////////需要修改的参数/////////////////
//商户编号
$appid = '20234861';
//商户密钥
$appkey = '26A2382b5Fe0bc4120a2597BC13D5E64';
//算法密钥
$deskey='XdgVewJk'; 
//数据库相关
$dbconfig = array(
    'db_host' => '127.0.0.1',
	'db_port' => '3306',
    'db_user' => 'root',
    'db_pass' => '123456',
	'db_mir'  => 'mir3',     //mir数据库
	'db_gold' => 'gamedata',//元宝数据库
);
///////////////////////////////////////////////
//下面代码基本不需要修改
if (empty($_POST)) $_POST = $_GET;  //如果为GET方式访问
if(version_compare(PHP_VERSION,'5.4.0','<')){
	outputError('PHP版本要求大于5.4.0');
}
if(!isset($_POST['appid'])){
	outputError('参数非法');
}
//验证商户号
if($_POST['appid']!=$appid){
	outputError('商户编号不正确');
}
if (!function_exists('openssl_encrypt')){
	outputError('请开启php.ini的openssl扩展');
}
//解密接口参数
$des = new Des();
$parameter=$_POST['parameter'];
$decode=$des->decrypt($parameter,$deskey);
if(empty($decode)){
	outputError('算法密钥不正确');
}
parse_str($decode, $data);
//验证商户密钥
if($appkey!=$data['appkey']){
	outputError('商户密钥不正确');
}

//开始充值
chongzhi($data);
function chongzhi($data){
	//全局变量，函数内调用需要加global声明
	global $dbconfig;
	$db_mir=$dbconfig['db_mir'];
	$db_gold=$dbconfig['db_gold'];
	try {
		$account = $data['account'];//账号
		$money = $data['money'];//充值金额
		$scale = $data['scale'];//充值比例
		$alias = $data['alias'];
		$yuanbao = intval($money * $scale);//游戏币=充值金额*充值比例
		$conn=@mysql_connect($dbconfig['db_host'],$dbconfig['db_user'],$dbconfig['db_pass'],$dbconfig['port']) or die("数据库连接失败,请联系管理员！");
		mysql_query("set names 'latin1'");//如果角色名为中文，可能会出现中文乱码，导致充值失败，可尝试设置数据库编码为latin1、gb2312、gbk、ASCII、UTF8MB4或者utf8
		$ChrName = iconv("UTF-8","gbk//TRANSLIT",$account);
		$result=mysql_query("SELECT * FROM `{$db_mir}`.`user_index` WHERE `ChrName`='$ChrName' LIMIT 1");
		if($result&&mysql_num_rows($result)>0){			
			 $row = mysql_fetch_array($result);
			 $userid=$row['UserId'];			 		 
			 /**
			  * 以下代码作废（不知道谁写的，真是乱来）
			  * 作废时间：2024年3月6日
			  * 三七博客：37boke.com
			  **
			 $result2=mysql_query("select AwardCodeType from `{$db_gold}`.`awardcodes` where OwnerPlayerID='$userid'");
			 $balance=0;//初始化余额
			 if($result2&&mysql_num_rows($result2)>0){
				 $row2 = mysql_fetch_array($result2);
				 $balance=intval($row2['AwardCodeType']);	
				 $yuanbao+=$balance;
			 }
			 */
			 $sql = "INSERT INTO `{$db_gold}`.`awardcodes` (AwardCode, AwardCodeType, ActiveParam, OwnerPlayerID, OwnerChrName) VALUES ('$ChrName', '$yuanbao', '1','$userid', '1') on duplicate key update AwardCodeType=$yuanbao,ActiveParam=1;";
			 mysql_query($sql);
			//成功后返回
			$text = $yuanbao>=10000?($yuanbao/10000).'万':$yuanbao;
			$msg = sprintf("账号[%s]成功充值金额%s元，获得%s：%s个",$account,$money,$alias,$text);
			outputSuccess($msg);
		}else{
			outputError('充值失败，角色不存在，角色名：'.$account);
		}
		mysql_close($conn);
	} catch (\Exception $e) {
		outputError('充值异常，Error：'.$e->getMessage());
	}
}

function outputError($msg){
	$arr=array('code'=>0,'msg'=>$msg);
	echo json_encode($arr, JSON_UNESCAPED_UNICODE);
	exit;
}

function outputSuccess($msg){
	$arr=array('code'=>1,'msg'=>$msg);
	echo json_encode($arr, JSON_UNESCAPED_UNICODE);
	exit;
}

/** 
 * 打印日志
 * $msg 日志内容
 */
function printLog($msg) {
	if (!is_dir('log')){
		mkdir('log',0777,true);
	}
	$path="log/".date('Y-m-d').".log";
	file_put_contents($path, "【" . date('Y-m-d H:i:s') . "】" . $msg . "\r\n\r\n", FILE_APPEND);
}